"use strict";
const GenSequence_1 = require("../src/GenSequence");
function* execRegEx(reg, text) {
    const regLocal = new RegExp(reg);
    let r;
    while (r = regLocal.exec(text)) {
        yield r;
    }
}
function match(reg, text) {
    return GenSequence_1.genSequence(execRegEx(reg, text))
        .map(a => a[0]);
}
function matchWords(text) {
    return GenSequence_1.genSequence(match(/\w+/g, text));
}
function toSetOfWords(text) {
    return new Set(matchWords(text));
}
exports.toSetOfWords = toSetOfWords;
exports.text = 'Some long bit of text with many words, duplicate words...';
exports.setOfWords = toSetOfWords(exports.text);
// Walk through the set of words and pull out the 4 letter one.
exports.setOf4LetterWords = new Set(GenSequence_1.genSequence(exports.setOfWords).filter(a => a.length === 4));
//# sourceMappingURL=match.js.map